#ifndef _ARCH_MIPS_KERNEL_UNALIGNED_H_
#define _ARCH_MIPS_KERNEL_UNALIGNED_H_


/*------------------------------------------------------------------------------------------*\
\*------------------------------------------------------------------------------------------*/
#define UNALIGNED_WARN  0x1 
#define UNALIGNED_BACKTRACE 0x8 

enum _unaligned_mode {
    UNALIGNED_ACTION_IGNORED        = 0,
    UNALIGNED_ACTION_IGNORED_WARN   = 1 | UNALIGNED_WARN,  /*-- verodern eigentlich Dummy :-) ---*/
	UNALIGNED_ACTION_FIXUP          = 2,
	UNALIGNED_ACTION_FIXUP_WARN     = 3 | UNALIGNED_WARN, /*-- verodern eigentlich Dummy :-) ---*/
	UNALIGNED_ACTION_SIGNAL         = 4,
	UNALIGNED_ACTION_SIGNAL_WARN    = 5 | UNALIGNED_WARN, /*-- verodern eigentlich Dummy :-) ---*/
	UNALIGNED_ACTION_FIXUP_WARN_BT     = UNALIGNED_ACTION_FIXUP_WARN | UNALIGNED_WARN | UNALIGNED_BACKTRACE
};


#ifdef CONFIG_DEBUG_FS
extern u32 unaligned_instructions;
#endif
extern int ai_usermode;
extern int ai_kernelmode;

extern void show_backtrace(struct task_struct *task, const struct pt_regs *regs);
#define unaligned_action ai_usermode

#endif /*--- #ifndef _ARCH_MIPS_KERNEL_UNALIGNED_H_ ---*/
